| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Public Member Functions | List of all members
nkWinUi::WindowingSystem Class Referenceabstract

Class abstracting the windowing system used. More...

## Public Member Functions
| WindowingSystem (System *system) noexcept
virtual | ~WindowingSystem ()
DataAllocator * | getAllocator () const
ComponentUtils * | getComponentUtils () const
InputProcessor * | getInputProcessor () const
SYSTEM_TYPE | getSystemType () const
virtual bool | load ()=0
virtual void | run ()=0
virtual void | tick ()=0
virtual void | prepareForShutdown ()=0
virtual void | shutdown ()=0
virtual void | notifyEvent ()=0

## Detailed Description

Class abstracting the windowing system used.

## Constructor & Destructor Documentation

## ◆ WindowingSystem()

nkWinUi::WindowingSystem::WindowingSystem | ( | System * | system | ) |
| noexcept

Constructor.

Parameters

  system | The parent main system.

Remarks
  The windowing system is created by its parent system during its initialization.

## ◆ ~WindowingSystem()

virtual nkWinUi::WindowingSystem::~WindowingSystem | ( |  | ) |
| virtual

Destructor.

Remarks
  The windowing system is erased by its parent system during its destruction.

## Member Function Documentation

## ◆ getAllocator()

DataAllocator* nkWinUi::WindowingSystem::getAllocator | ( |  | ) | const

Returns
  The system's data allocator.

## ◆ getComponentUtils()

ComponentUtils* nkWinUi::WindowingSystem::getComponentUtils | ( |  | ) | const

Returns
  The system's component utils.

## ◆ getInputProcessor()

InputProcessor* nkWinUi::WindowingSystem::getInputProcessor | ( |  | ) | const

Returns
  The system's input processor.

## ◆ getSystemType()

SYSTEM_TYPE nkWinUi::WindowingSystem::getSystemType | ( |  | ) | const

Returns
  The system type.

## ◆ load()

virtual bool nkWinUi::WindowingSystem::load | ( |  | ) |
| pure virtual

Prepares the system for use.

Remarks
  This is managed by the parent main system.

## ◆ run()

virtual void nkWinUi::WindowingSystem::run | ( |  | ) |
| pure virtual

Runs the system. This variant will loop inside, ticking as required.

Remarks
  This is managed by the parent main system.

## ◆ tick()

virtual void nkWinUi::WindowingSystem::tick | ( |  | ) |
| pure virtual

Ticks the system. This can be called in a custom loop to make the system move forward.

Remarks
  This is managed by the parent main system.

## ◆ prepareForShutdown()

virtual void nkWinUi::WindowingSystem::prepareForShutdown | ( |  | ) |
| pure virtual

Prepares the system for shutdown.

Remarks
  This is managed by the parent main system.

## ◆ shutdown()

virtual void nkWinUi::WindowingSystem::shutdown | ( |  | ) |
| pure virtual

Shuts down the system.

Remarks
  This is managed by the parent main system.

## ◆ notifyEvent()

virtual void nkWinUi::WindowingSystem::notifyEvent | ( |  | ) |
| pure virtual

Gives a dummy event to stimulate the system. For some systems that are working by waiting on events, this will trigger a tick.

The documentation for this class was generated from the following file:

- Documentation/Headers/NilkinsWinUi/WindowingSystems/WindowingSystem.h